#include "StdAfx.h"

#ifdef _DEBUG
/* visual leak detectorͷļڴй©⣬ûװע͵
 * ļĻ鲻Ҫӣٶȷǳ*/
//#include <vld.h>
#endif
#include "SeedResolver.h"

//׳쳣ʱǷжϣڵ
//#define BREAK_ON_THROW

using namespace std;

#pragma warning(disable : 4244 4996)

CSeedResolver::CSeedResolver(const CString& SeedFileName)
{
	ASSERT(!SeedFileName.IsEmpty());

	SeedInfo.Seed_FileName = SeedFileName;
}

CSeedResolver::~CSeedResolver(void)
{
	//
	DeallocAll();
}

//ѴдתΪСдȡӵıʽʱҪõ
void szCharToLower(char* pszString)
{
	int i = 0;
	while(pszString[i])
	{
		pszString[i] = tolower(pszString[i]);
		++i;
	}
}

BOOL CSeedResolver::Resolve()
{
	char* pBuffer = NULL;
	char* pShadowBuffer = NULL;

	HANDLE hFile = CreateFile(SeedInfo.Seed_FileName, GENERIC_READ,
		FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if(hFile == INVALID_HANDLE_VALUE) return FALSE;

	CFile file(hFile);
	m_SeedFileSize =(UINT) file.GetLength();
	m_Position = 0;

	if(!m_SeedFileSize) return FALSE;

	pBuffer =new char[m_SeedFileSize];
	file.Read((void*) pBuffer, m_SeedFileSize);
	file.Close();

	//ResovleBufferƶָ룬ԴһpBufferĸͷpBuffer
	pShadowBuffer = pBuffer;

	LPNode pNode = NULL;

#ifndef BREAK_ON_THROW
	try
	{
#endif
	
	pNode = ResovleBuffer(&pShadowBuffer);

#ifndef BREAK_ON_THROW
	}
	catch (int)
	{
		SAFE_RETURN(pBuffer, FALSE);
	}
#endif	
	
	//ļ
	SAFE_CLEAN(pBuffer);

	if(pNode->Type != BC_DICT) return FALSE;//Ǹbencodeֵ

	LPBC_Dict pRootDict= pNode->Data.bcDict;

	/* ʼȡֵ */

	//ȡӵıʽ
	if(GetNode(pRootDict, KEYWORD_ENCODING, &pNode))
	{
		szCharToLower(pNode->Data.bcString);
		if(!strlen(pNode->Data.bcString) || strcmp(pNode->Data.bcString, "utf-8") == 0)
			SeedInfo.Seed_Encoding = CP_UTF8;
		else if(strcmp(pNode->Data.bcString, "utf-7") == 0)//utf-7
			SeedInfo.Seed_Encoding = CP_UTF7;
		else if(strcmp(pNode->Data.bcString, "gbk") == 0)//
			SeedInfo.Seed_Encoding = 936;
		else if(strcmp(pNode->Data.bcString, "big5") == 0)//
			SeedInfo.Seed_Encoding = 950;
		else if(strcmp(pNode->Data.bcString, "shift_jis") == 0)//
			SeedInfo.Seed_Encoding = 932;
		else if(strcmp(pNode->Data.bcString, "windows-874") == 0)//̩
			SeedInfo.Seed_Encoding = 874;
		else if(strcmp(pNode->Data.bcString, "ks_c_5601-1987") == 0)//
			SeedInfo.Seed_Encoding = 949;
		else//Ϊutf-8
			SeedInfo.Seed_Encoding = CP_UTF8;
	}
	else
	{
		SeedInfo.Seed_Encoding = CP_UTF8;//ĬΪutf-8
	}

	//
	if(GetNode(pRootDict, KEYWORD_CREATION_DATE, &pNode) && pNode->Type == BC_INT)
	{
		CTime time(0);
		CTimeSpan ts(pNode->Data.bcInt);

		time += ts;
		SeedInfo.Seed_CreationDate.Format(_T("%d%.2d%.2d %.2dʱ%.2d"), time.GetYear(),
			time.GetMonth(), time.GetDay(), time.GetHour(), time.GetMinute());
	}
	else
	{
		SeedInfo.Seed_CreationDate = _T("(δ֪)");
	}

	//ӵıע
	if(GetNode(pRootDict, KEYWORD_COMMENT_UTF8, &pNode) && pNode->Type == BC_STRING)//ȿûutf-8
	{
		ConvertToUnicode(pNode->Data.bcString, SeedInfo.Seed_Comment, CP_UTF8);
	}
	else if(GetNode(pRootDict, KEYWORD_COMMENT_UTF8, &pNode) && pNode->Type == BC_STRING)//ûutf-8ľʹñ
	{
		ConvertToUnicode(pNode->Data.bcString, SeedInfo.Seed_Comment);
	}
	else
	{
		SeedInfo.Seed_Comment = _T("(ûбע)");
	}

	//ӵĴ
	if(GetNode(pRootDict, KEYWORD_CREATED_BY, &pNode) && pNode->Type == BC_STRING)
	{
		ConvertToUnicode(pNode->Data.bcString, SeedInfo.Seed_Creator, CP_UTF8);
	}
	else
	{
		SeedInfo.Seed_Creator = _T("(δ֪)");
	}

	//ӵķ
	if(GetNode(pRootDict, KEYWORD_PUBLISHER_UTF8, &pNode) &&//ȿûutf-8
		pNode->Type == BC_STRING)
	{
		ConvertToUnicode(pNode->Data.bcString, SeedInfo.Seed_Publisher, CP_UTF8);
	}
	else if(GetNode(pRootDict, KEYWORD_PUBLISHER, &pNode) &&//ûutf-8ľʹñ
		pNode->Type == BC_STRING)
	{
		ConvertToUnicode(pNode->Data.bcString, SeedInfo.Seed_Publisher);
	}
	else
	{
		SeedInfo.Seed_Publisher = _T("(δ֪)");
	}

	//ȡڵļ
	LPBC_Dict pInfoDict = NULL;//infoֵ
	
	if(!GetNode(pRootDict, KEYWORD_INFO, &pNode) || pNode->Type != BC_DICT) return FALSE;

	pInfoDict = pNode->Data.bcDict;
	pNode = NULL;

	GetNode(pInfoDict, KEYWORD_FILES, &pNode);

	//pNodeΪNULLûҵؼKEYWORD_FILESôǸļӣΪļӻЧ
	if(!pNode)
	{
		InnerFile iFile;
		int nCodePage = 0;

		//ļģʽinfoֵnameؼļ
		if(GetNode(pInfoDict, KEYWORD_NAME_UTF8, &pNode))
			nCodePage = CP_UTF8;
		else if(GetNode(pInfoDict, KEYWORD_NAME, &pNode))
			nCodePage = 0;
		else
			return FALSE;

		if(pNode->Type != BC_STRING) return FALSE;

		ConvertToUnicode(pNode->Data.bcString, iFile.FileName, nCodePage);
		iFile.PathName = _T("\\");

		//ļС
		if(!GetNode(pInfoDict, KEYWORD_LENGTH, &pNode) ||
			pNode->Type != BC_INT)
			return FALSE;
		else
			iFile.FileSize = pNode->Data.bcInt;

		SeedInfo.Seed_Files.push_back(iFile);
	}
	else if(pNode->Type == BC_LIST)
	{
		/* Ĵе㲻̫׿ҶⶨpFileDictpPathList
		 * ʹЩֻҪסLPBC_DictָBC_Dictṹָ룬LPBC_List
		 * ָNodeṹָָ*/
		LPBC_List pFileList = pNode->Data.bcList;//infoֵڵfilesб

		while(*pFileList)
		{
			if((*pFileList)->Type != BC_DICT) return FALSE;//ÿбĿ붼ֵ
			
			LPBC_Dict pFileDict = (*pFileList)->Data.bcDict;

			InnerFile iFile;
			int nCodePage = 0;

			//ȷҳȡpathб
			if(GetNode(pFileDict, KEYWORD_PATH_UTF8, &pNode))
				nCodePage = CP_UTF8;
			else if(GetNode(pFileDict, KEYWORD_PATH, &pNode))
				nCodePage = 0;
			else
				return FALSE;

			if(pNode->Type != BC_LIST) return FALSE;//pathб

			LPBC_List pPathList = pNode->Data.bcList;
			vector<CString> vecTemp;//ʱ洢

			while(*pPathList)
			{
				if((*pPathList)->Type != BC_STRING) return FALSE;//pathÿĿַ
				
				CString s;

				ConvertToUnicode((*pPathList)->Data.bcString, s, nCodePage);
				vecTemp.push_back(s);

				++(pPathList);
			}

			//ҪvecTempнֽļĿ¼
			if(vecTemp.front().Find(_T(BITCOMET_PADDING_FILE_PREFIX)) != 0)//BitCometǶļ
			{
				iFile.FileName = vecTemp.back();
				vecTemp.pop_back();
				for(vector<CString>::iterator iter = vecTemp.begin(); iter != vecTemp.end(); ++iter)
				{
					iFile.PathName += *iter + _T("\\");
				}
				if(iFile.PathName.IsEmpty()) iFile.PathName = _T("\\");


				//ȡļС
				if(!GetNode(pFileDict, KEYWORD_LENGTH, &pNode) ||
					pNode->Type != BC_INT)
					return FALSE;
				else
					iFile.FileSize = pNode->Data.bcInt;

				//iFileSeedInfo.Seed_Files
				SeedInfo.Seed_Files.push_back(iFile);
			}

			++pFileList;
		}
	}
	else
		return FALSE;

	return TRUE;
}

LPNode CSeedResolver::ResovleBuffer( char** pBuffer )
{
	LPNode pNode = NULL;

	switch(**pBuffer)
	{
	case '0':case '1':case '2':	case '3':case '4':case '5':	case '6':case '7':case '8':case '9':
		pNode =(LPNode) malloc(sizeof(Node));

		pNode->Type = BC_STRING;
		pNode->Data.bcString = GetBCString(pBuffer);//ñGetBCStringصָ룬GetBCStringǷ񱣴ָ
		vecAllocated.push_back((INT_PTR) pNode);

		if(!pNode->Data.bcString) throw NULL;//ļд
		break;
	case BC_PREFIX_INT:
		pNode =(LPNode) malloc(sizeof(Node));

		pNode->Type = BC_INT;
		pNode->Data.bcInt = GetBCInt(pBuffer);
		vecAllocated.push_back((INT_PTR) pNode);

		if(pNode->Data.bcInt == _I64_MAX) throw NULL;//ļд
		break;
	case BC_PREFIX_LIST:
		{
			//ͷBC_PREFIX_LIST
			++(*pBuffer);
			++m_Position;

			pNode =(LPNode) malloc(sizeof(Node));
			
			pNode->Type = BC_LIST;
			pNode->Data.bcList = NULL;
			vecAllocated.push_back((INT_PTR) pNode);

			UINT i = 0;

			while(**pBuffer != BC_SUFFIX)
			{
				pNode->Data.bcList = (LPBC_List) realloc((void*) pNode->Data.bcList, (i + 2)/*һԪشNULL*/ * sizeof(BC_List));

				try
				{
					pNode->Data.bcList[i] = ResovleBuffer(pBuffer);
				}
				catch (INT)
				{
					vecAllocated.push_back((INT_PTR) pNode->Data.bcList);
					throw NULL;
				}

				++i;
			}

			/* ǸѭļдǸбһζִУ׳쳣 */
			if(!i)
				throw NULL;
			else
				vecAllocated.push_back((INT_PTR) pNode->Data.bcList);

			/* bcListǸָĶ̬飨BC_ListʵLPNode޷ȷ̬ĳȣΪbcListռʱ
			 * һԪصĿռ䣬ΪԪظֵNULLͬ׼cַһNULL
			 * β̬ʱ򣬶NULLΪ*/
			pNode->Data.bcList[i] = NULL;

			//βBC_SUFFIX
			++(*pBuffer);
			++m_Position;
		}
		break;
	case BC_PREFIX_DICT:
		{
			//bencodeֵĽɲοĶbencodeбĽ
			++(*pBuffer);
			++m_Position;

			pNode = (LPNode) malloc(sizeof(Node));
			pNode->Type = BC_DICT;
			pNode->Data.bcDict = NULL;
			vecAllocated.push_back((INT_PTR) pNode);

			UINT i = 0;
			while(**pBuffer != BC_SUFFIX)
			{
				pNode->Data.bcDict = (LPBC_Dict) realloc((void*) pNode->Data.bcDict, (i + 2) * sizeof(BC_Dict));
				
				try
				{
					pNode->Data.bcDict[i].pszKey = GetBCString(pBuffer);
					if(!pNode->Data.bcDict[i].pszKey) throw NULL;//GetBCString׳쳣Ա鷵ֵ
					pNode->Data.bcDict[i].pNode = ResovleBuffer(pBuffer);
				}
				catch (INT)
				{
					vecAllocated.push_back((INT_PTR) pNode->Data.bcList);
					throw NULL;
				}

				++i;
			}

			if(!i)
				throw NULL;
			else
				vecAllocated.push_back((INT_PTR) pNode->Data.bcList);

			/* ֵ洦бе㲻һbcDictԪزָ룬ԾͰѽβԪصpszKeyNULL
			 * bcDictʱĳԪصKeyNULLʱΪ */
			pNode->Data.bcDict[i].pszKey = NULL;

			++(*pBuffer);
			++m_Position;
		}
		break;
	default:
		//Чbencodeǰ׺ֱ׳쳣
		throw NULL;
		break;
	}

	

	return pNode;
}
void CSeedResolver::DeallocAll()
{
	for(vector<INT_PTR>::iterator iter = vecAllocated.begin();
		iter != vecAllocated.end();
		++iter)
	{
		free((void*) *iter);
	}
}

BOOL CSeedResolver::IsRangeValid( UINT nOffset /* = 0 */ )
{
	return m_Position + nOffset <= m_SeedFileSize;
}

char* CSeedResolver::GetBCString( char** pBuffer )
{
	char* pszRet = NULL;
	char* pszStrLen;
	UINT nLen = 0;

	//bencodeַ0-9ֿʼ
	if(**pBuffer < '0' || **pBuffer >'9')
		return pszRet;

	while(*(*pBuffer + nLen) != BC_STRING_DELIMITER)
	{
		++nLen;
		
		//ǷԽ
		if(!IsRangeValid(nLen))	return pszRet;
	}

	//nLenΪbcstringǰıʾbcstringȵַ
	pszStrLen = new char[nLen + 1];
	ZeroMemory(pszStrLen, nLen + 1);
	memcpy((void*) pszStrLen, (void*) *pBuffer, nLen);

	//ǷԽ
	if(!IsRangeValid(nLen + 1)) return pszRet;

	//ƶָ
	*pBuffer += nLen + 1/* 1Ϊ':' */;
	m_Position += nLen + 1;

	//nLenʱΪbcstringĳ
	nLen = atoi(pszStrLen);
	SAFE_CLEAN(pszStrLen);

	if(!nLen)//nLen=0Ǹַ
	{
		pszRet = (char*) malloc(sizeof(char));
		pszRet[0] = '\0';
		vecAllocated.push_back((INT_PTR) pszRet);
	}
	else
	{
		//ǷԽ
		if(!IsRangeValid(nLen)) return pszRet;

		pszRet = (char*) malloc((nLen + 1) * sizeof(char));
		memset((void*) pszRet, NULL, nLen + 1);
		vecAllocated.push_back((INT_PTR) pszRet);
		memcpy((void*) pszRet, (void*) *pBuffer, nLen);
	}

	//ƶָ
	*pBuffer += nLen;
	m_Position += nLen;

	return pszRet;
}

DWORDLONG CSeedResolver::GetBCInt( char** pBuffer )
{
	DWORDLONG dwlRet = _I64_MAX;
	char* psz;
	UINT nLen = 0;

	//bencodeiʼ
	if(**pBuffer != BC_PREFIX_INT)
		return dwlRet;

	//ǷԽ
	if(!IsRangeValid(1)) return dwlRet;

	++(*pBuffer);
	++m_Position;

	while(m_Position <= m_SeedFileSize && *(*pBuffer + nLen) != BC_SUFFIX)
	{
		++nLen;

		//ǷԽ
		if(!IsRangeValid(nLen)) return dwlRet;
	}

	psz = new char[nLen + 1];
	ZeroMemory(psz, nLen + 1);
	memcpy((void*) psz, (void*) *pBuffer, nLen);
	if(*psz == '0' && nLen == 1)//0bencodeЧ
		dwlRet = 0;
	else
		dwlRet = _atoi64(psz) ? _atoi64(psz) : _I64_MAX;
	SAFE_CLEAN(psz);

	//ǷԽ
	if(!IsRangeValid(nLen + 1)) return _I64_MAX;

	//ƶָ
	*pBuffer += nLen + 1/* 1Ϊ'e' */;
	m_Position += nLen + 1;

	return dwlRet;
}

BOOL CSeedResolver::GetNode( LPBC_Dict pDict, const char* pszKey, _Out_ LPNode* pNode )
{
	if(!pDict) return FALSE;

	while(pDict->pszKey)//pszKeyж϶̬Ƿ
	{
		if(strcmp(pDict->pszKey, pszKey) == 0)
		{
			*pNode = pDict->pNode;
			return TRUE;
		}

		++pDict;
	}

	return FALSE;
}

void CSeedResolver::ConvertToUnicode( const char* pStr ,CString& s, int nCodePage /*= 0*/ )
{
	wchar_t* szUnicode = NULL;
	UINT nLen;
	int nCP;

	if(!pStr) return;

	/* ַãӦԶ룬Ҷַı벻죬ֻʱûз*/
	if(!nCodePage)//ûָҳʹڶĴҳ
		nCP = SeedInfo.Seed_Encoding;
	else
		nCP = nCodePage;

	nLen = MultiByteToWideChar(nCP, NULL, pStr, strlen(pStr) + 1, NULL, NULL);
	szUnicode = new wchar_t[nLen];
	MultiByteToWideChar(nCP, NULL, pStr, strlen(pStr) + 1, szUnicode, nLen);

	s.Format(_T("%s"), szUnicode);

	SAFE_CLEAN(szUnicode);
}
